#include "../freebl/fips-selftest.inc"

#include "fips.h"

#include "softoken.h"

#include <dlfcn.h>

/* crypto algorithms selftest wrapper */
static fips_check_status
fips_checkCryptoSoftoken(void)
{
    if (CKR_OK == sftk_FIPSEntryOK()) {
	return CHECK_OK;
    } else {
	return CHECK_FAIL_CRYPTO;
    }

    return CHECK_OK;
}

/* constructor - load-time selfchecks */
static void __attribute__ ((constructor))
fips_initTestSoftoken(void)
{
    fips_state = fips_initTest("softokn", (PRFuncPtr)fips_initTestSoftoken, fips_checkCryptoSoftoken);

    /* The legacy DB must be checked unconditionally in FIPS mode. As an exception,
     * this can be turned off for the build-time tests using the env var
     * NSS_IGNORE_CHECKSUMS. This is necessary because the files cannot be
     * located before they're installed. It only works if FIPS mode is enabled
     * via NSS_FIPS=1, not if it's set in /proc. */

    if (fips_state && !(fips_is_env && fips_ignore_checksums))
    {
        fips_state = fips_initTest("nssdbm", (PRFuncPtr) NULL, NULL);
    }

    return;
}

void
fips_repeatTestSoftoken(void)
{
    fips_initTestSoftoken();
}
